=== examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_EXAMPLES)

ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/datasets     datasets)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/datatypes   datatypes)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/groups      groups)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/intro       intro)
