=== native/hdf5lib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_JNI_HDF5LIB C)

SET (HDFJAVA_JNI_HDF5_CSRCS
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/exceptionImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5aImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5Constants.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5dImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5eImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5fImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5gImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5iImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5Imp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5lImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5oImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5pImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5rImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5sImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5tImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5util.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5zImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/nativeData.c
)

SET (HDFJAVA_JNI_HDF5_CHDRS
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5dImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5eImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5fImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5gImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5jni.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5lImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5oImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5sImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5tImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5util.h
)

INCLUDE_DIRECTORIES( ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR} )

########### JNI libraries always must be built shared  ###############
ADD_LIBRARY (${HDFJAVA_JNI_HDF5_LIB_TARGET} SHARED ${HDFJAVA_JNI_HDF5_CSRCS} ${HDFJAVA_JNI_HDF5_CHDRS})
TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF5_LIB_TARGET} ${HDF5_LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFJAVA_LIBRARIES_TO_EXPORT "${HDFJAVA_LIBRARIES_TO_EXPORT};${HDFJAVA_JNI_HDF5_LIB_TARGET}")
HDFJAVA_SET_LIB_OPTIONS (${HDFJAVA_JNI_HDF5_LIB_TARGET} ${HDFJAVA_JNI_HDF5_LIB_NAME} SHARED)
IF (WIN32 AND NOT CYGWIN)
  GET_FILENAME_COMPONENT(HDFJAVA_JNI_HDF5_DLL_NAME ${HDFJAVA_JNI_HDF5_LIB_TARGET} NAME_WE)
  # MESSAGE (STATUS "HDFJAVA_JNI_HDF5_DLL_NAME: ${HDFJAVA_JNI_HDF5_DLL_NAME}")
  IF (BUILD_TESTING)
    ADD_CUSTOM_TARGET (HDFJAVA_JNI_HDF5-Test-Copy ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        COMMENT "Copying ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/"
    )
    ADD_DEPENDENCIES (HDFJAVA_JNI_HDF5-Test-Copy ${HDFJAVA_JNI_HDF5_LIB_TARGET})
  ENDIF (BUILD_TESTING)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFJAVA_EXPORTED_TARGETS)
  INSTALL (
      TARGETS 
          ${HDFJAVA_JNI_HDF5_LIB_TARGET}
      EXPORT
          ${HDFJAVA_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
  )
ENDIF (HDFJAVA_EXPORTED_TARGETS)
