=== native/hdflib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_JNI_HDFLIB C)

SET (HDFJAVA_JNI_HDF_CSRCS
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfanImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfanImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfcompImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfpalImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfsdImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfuImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfexceptionImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfgrImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfheImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfhxImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfnativeImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfr24Imp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfr8Imp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfsdsImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfstructsutil.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvdataImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvfImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvgroupImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvhImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvqImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvsqImp.c
)

INCLUDE_DIRECTORIES( ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR} )

########### JNI libraries always must be built shared  ###############
ADD_LIBRARY (${HDFJAVA_JNI_HDF_LIB_TARGET} SHARED ${HDFJAVA_JNI_HDF_CSRCS})
IF (WIN32 AND NOT CYGWIN)
  TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDF4_LINK_LIBS} "ws2_32.lib")
ELSE (WIN32 AND NOT CYGWIN)
  TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDF4_LINK_LIBS})
ENDIF (WIN32 AND NOT CYGWIN)
SET_GLOBAL_VARIABLE (HDFJAVA_LIBRARIES_TO_EXPORT "${HDFJAVA_LIBRARIES_TO_EXPORT};${HDFJAVA_JNI_HDF_LIB_TARGET}")
HDFJAVA_SET_LIB_OPTIONS (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDFJAVA_JNI_HDF_LIB_NAME} SHARED)
IF (WIN32 AND NOT CYGWIN)
  GET_FILENAME_COMPONENT(HDFJAVA_JNI_HDF_DLL_NAME ${HDFJAVA_JNI_HDF_LIB_TARGET} NAME_WE)
  # MESSAGE (STATUS "HDFJAVA_JNI_HDF_DLL_NAME: ${HDFJAVA_JNI_HDF_DLL_NAME}")
  IF (BUILD_TESTING)
    ADD_CUSTOM_TARGET (HDFJAVA_JNI_HDF-Test-Copy ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        COMMENT "Copying ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/"
    )
    ADD_DEPENDENCIES (HDFJAVA_JNI_HDF-Test-Copy ${HDFJAVA_JNI_HDF_LIB_TARGET})
  ENDIF (BUILD_TESTING)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFJAVA_EXPORTED_TARGETS)
  INSTALL (
      TARGETS 
          ${HDFJAVA_JNI_HDF_LIB_TARGET}
      EXPORT
          ${HDFJAVA_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
  )
ENDIF (HDFJAVA_EXPORTED_TARGETS)
