=== ncsa/hdf/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_NCSA_HDF)

ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/hdflib      hdflib)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/hdf5lib     hdf5lib)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/object      object)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/view        view)
