=== test/object/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_TEST_OBJECT Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF4_BINARY_DIR}
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${JAVA_NCSA_HDF_OBJECT_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDFJAVA_TEST_OBJECT_SRCS
    AllH5ObjectTests.java
    AttributeTest.java
    CompoundDSTest.java
    DatasetTest.java
    DatatypeTest.java
    DataFormatTest.java
    FileFormatTest.java
    GroupTest.java
    H5BugFixTest.java
    H5CompoundDSTest.java
    H5DatatypeTest.java
    H5FileTest.java
    H5GroupTest.java
    H5ScalarDSTest.java
    H5TestFile.java
    HObjectTest.java
    MetadataTest.java
    ScalarDSTest.java
)

FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
"Main-Class: test.object.AllH5ObjectTests

"
)

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_LIB_DIR}/junit.jar;${HDFJAVA_OBJECT_JARS};${HDFJAVA_HDF5_JARS}")

ADD_JAR (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${PROJECT_BINARY_DIR}/Manifest.txt ${HDFJAVA_TEST_OBJECT_SRCS})

GET_TARGET_PROPERTY(${HDFJAVA_TEST_OBJECT_LIB_TARGET}_JAR_FILE ${HDFJAVA_TEST_OBJECT_LIB_TARGET} JAR_FILE)
#INSTALL_JAR (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${HJAVA_INSTALL_DATA_DIR}/tests tests)

ADD_DEPENDENCIES (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${HDFJAVA_NCSA_HDF5_LIB_TARGET} ${HDFJAVA_NCSA_H5_LIB_TARGET})

SET (HDF_JAVA_TEST_FILES
      h5ex_d_extern.data
      h5ex_d_extern.hdf5
      JUnit-object-interface.txt
)

FOREACH (h5_file ${HDF_JAVA_TEST_FILES})
  SET (dest "${PROJECT_BINARY_DIR}/${h5_file}")
  #MESSAGE (STATUS " Copying ${h5_file}")
  ADD_CUSTOM_COMMAND (
      TARGET     ${HDFJAVA_TEST_OBJECT_LIB_TARGET}
      POST_BUILD
      COMMAND    ${CMAKE_COMMAND}
      ARGS       -E copy_if_different ${PROJECT_SOURCE_DIR}/${h5_file} ${dest}
  )
ENDFOREACH (h5_file ${HDF_JAVA_TEST_FILES})

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)
SET (CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${HDFJAVA_TEST_OBJECT_LIB_TARGET}_JAR_FILE}")
SET (testfilter "OK (153 tests)")

ADD_TEST (
    NAME JUnit-object-interface
    COMMAND "${CMAKE_COMMAND}"
        -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
        -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}"
        -D "TEST_ARGS:STRING="
        -D "TEST_PROGRAM=-ea;org.junit.runner.JUnitCore;test.object.AllH5ObjectTests"
        -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
        -D "TEST_FOLDER=${HDFJAVA_BINARY_DIR}"
        -D "TEST_OUTPUT=${HDFJAVA_TEST_OBJECT_BINARY_DIR}/JUnit-object-interface.out"
        -D "TEST_EXPECT=0"
        -D "TEST_FILTER:STRING=${testfilter}"
        -D "TEST_REFERENCE=${testfilter}"
        -D "TEST_SKIP_COMPARE=TRUE"
        -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
)
