=== debian/changelog ===
jhdf (2.9-1) unstable; urgency=low

  * Upload to unstable
  * Disable the shipping of all setting files (Closes: #713190)
  * Standards-Version updated to 3.9.4
  * Remove the -v option to autoreconf
  * Update of the .install path of libjhdf5

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 28 May 2013 18:32:17 +0200

jhdf (2.9-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 05 Dec 2012 11:45:18 +0100

jhdf (2.8.0-6~exp1) experimental; urgency=low

  [ James Page ]
  * Drop build dependencies on openjdk-{6|7}-jdk,
    version default-jdk (>= 1:1.6).
    (Closes: #683552)
  * d/patches/source1.5.diff: Also set -target 1.5 to ensure backwards
    compatible bytecode is created.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 02 Aug 2012 10:00:13 +0200
