=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008 Sylvestre Ledru <sylvestre.ledru@inria.fr>

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

debian/stamp-autotools-files:
	autoreconf -i
	touch debian/stamp-autotools-files


DEB_CONFIGURE_EXTRA_FLAGS := CC=gcc

DEB_CONFIGURE_NORMAL_ARGS += --with-jdk=/usr/lib/jvm/default-java/include/,/usr/lib/jvm/default-java/lib/ --with-classpath=/usr/lib/jvm/default-java/lib/ --with-javabin=/usr/lib/jvm/default-java/bin/  --with-libz=yes,/usr/lib  --with-libjpeg=yes,/usr/lib/   --with-hdf5=/usr/include,/usr/lib --with-hdf4=/usr/include/hdf/,/usr/lib/
DEB_CONFIGURE_PREFIX := $(CURDIR)/debian/tmp/
