=== debian/watch ===
version=3
http://www.hdfgroup.org/ftp/HDF5/hdf-java/src/ \
hdf-java-([\d\.]+)-src.tar \
debian debian/orig-tar.sh
